/*
	Eric multiplayer script - ATG - NVA base
*/

#include <inc\sc_global.h>
#include <inc\sc_def.h>


#define NORECOV_TIME	3.0f		// disable time of recoverplace after recovering someone there

#define REC_WPNAME_US	"USSpawn_atg_%d"
#define REC_WPNAME_VC	"VCSpawn_atg_%d"
#define REC_MAX			64


#define GVAR_SIDE0POINTS				500
#define GVAR_SIDE1POINTS				501

#define GVAR_BOMBSTATUS					502
#define GVAR_BOMBTIMER					503

#define GVAR_MISSIONTIME				504
#define GVAR_MISSIONTIME_UPDATE			505

#define BOMB_STATUS_STARTING			0
#define BOMB_STATUS_INACTIVE			1
#define BOMB_STATUS_ACTIVE				2
#define BOMB_STATUS_EXPLODED			3
#define BOMB_STATUS_US_KILLED			4
#define BOMB_STATUS_VC_KILLED			5
#define BOMB_STATUS_DRAW				6
#define BOMB_STATUS_TIMEOUT				7

#define BOMB_TIMER						(30.0f)
#define BOMB_TIMER_UPDATE				(5.4f)
#define BOMB_AFTER_EXPLODE_TIMER		(5.0f)


dword gRecs[2] = {0,0};
s_SC_MP_Recover gRec[2][REC_MAX];
float gRecTimer[2][REC_MAX];

c_Vector3 gBombWorldPos;

int gSidePoints[2] = {0,0};

int gCLN_SidePoints[2];

void *gC4nod;

dword gBombStatus = BOMB_STATUS_STARTING;
float gBombTimer;
float gAfterExplodeTimer;

float gMissionTime = 0;
float gMissionTime_update = 0;

float gCLN_MissionTime = 0;
dword gCLN_MissionTimePrevID = 0;

float gUpdate_BombTimer;
float gRecv_BombTimer;
float gCLN_BombTimer;

dword gCLN_BombStatus;

float gStartTimer;
float gRestartTimer;

BOOL gInstantRecover = FALSE;

dword gEndRule;
dword gEndValue;
float gTime;

#if _GE_VERSION_ >= 138
dword g_FPV_BombZone = 0;
#endif


BOOL SRV_CheckEndRule(float time){

	switch(gEndRule){
		case SC_MP_ENDRULE_TIME:
			
			if (gBombStatus!=BOMB_STATUS_STARTING) gTime += time;

			SC_MP_EndRule_SetTimeLeft(gTime,gBombStatus!=BOMB_STATUS_STARTING);

			if (gTime>gEndValue){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		case SC_MP_ENDRULE_POINTS:

			if ((gSidePoints[0]>=gEndValue)||(gSidePoints[1]>=gEndValue)){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		default:
			SC_message("EndRule unsopported: %d",gEndRule);
			break;

	}// switch(gEndRule)

	return FALSE;

}// void SRV_CheckEndRule(float time)

void UpdateSidePoints(void){
	SC_sgi(GVAR_SIDE0POINTS,gSidePoints[0]);
	SC_sgi(GVAR_SIDE1POINTS,gSidePoints[1]);
}// void UpdateSidePoints(void)


void SRV_CheckTimer(float time){

	if (gBombStatus==BOMB_STATUS_ACTIVE){

		gBombTimer -= time;

		if (gBombTimer<=0.0f){
			// explosion
			SC_DoExplosion(&gBombWorldPos,SC_EXPL_TYPE_MORTAR);
			gBombStatus = BOMB_STATUS_EXPLODED;
			SC_sgi(GVAR_BOMBSTATUS,gBombStatus);	
			gAfterExplodeTimer = BOMB_AFTER_EXPLODE_TIMER;
			gSidePoints[0]++;
			UpdateSidePoints();

		}
		else{
			gUpdate_BombTimer -= time;
			if (gUpdate_BombTimer<=0.0f){
				gUpdate_BombTimer = BOMB_TIMER_UPDATE;
				SC_sgf(GVAR_BOMBTIMER,gBombTimer);
			}
		}

	}// if (gBombStatus==BOMB_STATUS_ACTIVE)

}// void SRV_CheckTimer(float time)


void SRV_InstantRecover(BOOL valid){

	gInstantRecover = valid;

	SC_MP_SetInstantRecovery(valid);

}// void SRV_InstantRecover(BOOL valid)

void SRV_UpdateMissionTime(float time){

	gMissionTime_update -= time;
	if (gMissionTime_update<0.0f){

		gMissionTime_update = 10.0f;

		SC_sgf(GVAR_MISSIONTIME,gMissionTime);
		SC_sgi(GVAR_MISSIONTIME_UPDATE,SC_ggi(GVAR_MISSIONTIME_UPDATE)+1);		
	}// if (gMissionTime_update<0.0f)
}



void Check_ABL(void){
	int val;
	dword side,nr_to_change;
	s_SC_P_getinfo info;
	s_SC_MP_EnumPlayers enum_pl[64];
	dword i,j,k;


	if (!SC_MP_SRV_GetAutoTeamBalance()) return;

	val = SC_MP_SRV_GetTeamsNrDifference(TRUE);

	if ((val<3)&&(val>-3)) return;	// no big difference

	if (val>0){
		side = 0;
		nr_to_change = val/2;
	}
	else{
		side = 1;
		nr_to_change = -val/2;
	}
	

	// find nr_to_change players of beste players of side 0
	

	j = 64;

	if (SC_MP_EnumPlayers(enum_pl,&j,side)){				

		if (!j) return;
		
		while(nr_to_change!=0){

			k = rand()%j;
			i = k;

			while(
				(enum_pl[i].id==0)
				||(enum_pl[i].status==SC_MP_P_STATUS_NOTINGAME)){

				i++;
				if (i==j) i = 0;
				if (i==k) return;	// no valid found
			}						

			SC_MP_SRV_P_SetSideClass(enum_pl[i].id,1-side,1 + 20*(1-side));
			enum_pl[i].id = 0;

			nr_to_change--;

		}// while(nr_to_change!=0)
							
	}// if (SC_MP_EnumPlayers(enum_pl,&j,SC_MP_ENUMPLAYER_SIDE_ALL))



}// void Check_ABL(dword pl_handle)




int ScriptMain(s_SC_NET_info *info){
	char txt[32];
	dword i,j,side,text_id;
	s_SC_MP_Recover *precov;
	s_SC_MP_hud hudinfo;
	s_SC_P_getinfo plinfo;
	float val;
	void *nod;
	s_SC_MP_EnumPlayers enum_pl[64];
	BOOL valid[2],active;
	s_SC_HUD_MP_icon icon[10];
	s_SC_MP_SRV_settings SRVset;
	s_SC_MP_SRV_AtgSettings atgset;
#if _GE_VERSION_ >= 138
	s_SC_FpvMapSign fpv_list[2];
#endif

	switch(info->message){
		
		case SC_NET_MES_SERVER_TICK:	
			

			if (SRV_CheckEndRule(info->elapsed_time)) break;

			for (j=0;j<2;j++)
			for (i=0;i<gRecs[j];i++)
				gRecTimer[j][i] -= info->elapsed_time;


			CLEAR(valid);			
			j = 64;

			if (SC_MP_EnumPlayers(enum_pl,&j,SC_MP_ENUMPLAYER_SIDE_ALL)){				

				if ((j==0)&&((gSidePoints[0]+gSidePoints[1])!=0)){
					gSidePoints[0] = 0;
					gSidePoints[1] = 0;
					UpdateSidePoints();
				}// if ((side[0]+side[1])==0)

				for (i=0;i<j;i++)
					if (enum_pl[i].status==SC_MP_P_STATUS_INGAME) valid[enum_pl[i].side] = TRUE;
					
			}// if (SC_MP_EnumPlayers(enum_pl,&j,SC_MP_ENUMPLAYER_SIDE_ALL))


			i = SC_ggi(GVAR_BOMBSTATUS);

			
			SRV_InstantRecover(FALSE);
			
			switch(gBombStatus){

				case BOMB_STATUS_STARTING:					

						gRestartTimer += info->elapsed_time;

						if ((valid[0])&&(valid[1])){

							if (gRestartTimer>10.0f){
								Check_ABL();
								SC_MP_SRV_InitGameAfterInactive();
								SC_MP_RestartMission();
								gRestartTimer = 0.0f;						
							}
							else{
								gBombStatus = BOMB_STATUS_INACTIVE;
								SC_sgi(GVAR_BOMBSTATUS,BOMB_STATUS_INACTIVE);
								gStartTimer = 0.0f;

								SC_MP_SRV_GetAtgSettings(&atgset);

								if (atgset.ATG_round_time>29.0f)
									gMissionTime = atgset.ATG_round_time;
								else
									gMissionTime = 240.0f;

								SRV_UpdateMissionTime(1000);
							}

						}// if ((valid[0])&&(valid[1]))


						SRV_InstantRecover(TRUE);						

						break;// BOMB_STATUS_STARTING

				case BOMB_STATUS_EXPLODED:
				case BOMB_STATUS_US_KILLED:
				case BOMB_STATUS_VC_KILLED:
				case BOMB_STATUS_DRAW:
				case BOMB_STATUS_TIMEOUT:
						
						gAfterExplodeTimer -= info->elapsed_time;

						if (gAfterExplodeTimer<=0.0f){
							Check_ABL();
							SC_MP_RestartMission();
							gBombStatus = BOMB_STATUS_STARTING;
							SC_sgi(GVAR_BOMBSTATUS,BOMB_STATUS_STARTING);
							gRestartTimer = 0.0f;								
						}// if (gAfterExplodeTimer<=0.0f)
						else{
							if (i!=gBombStatus) SC_sgi(GVAR_BOMBSTATUS,gBombStatus);			
						}

						break;

				default:

						gStartTimer += info->elapsed_time;

						if (gStartTimer>5.0f){

							if ((!valid[0])&&(!valid[1])){
								// draw																		
								gBombStatus = BOMB_STATUS_DRAW;
								SC_sgi(GVAR_BOMBSTATUS,gBombStatus);	
								gAfterExplodeTimer = BOMB_AFTER_EXPLODE_TIMER;								
								break;
							}

							if ((!valid[0])&&(gBombStatus==BOMB_STATUS_INACTIVE)){
								gBombStatus = BOMB_STATUS_US_KILLED;
								SC_sgi(GVAR_BOMBSTATUS,gBombStatus);	
								gAfterExplodeTimer = BOMB_AFTER_EXPLODE_TIMER;
								gSidePoints[1]++;
								UpdateSidePoints();
								break;
							}

							if (!valid[1]){
								gBombStatus = BOMB_STATUS_VC_KILLED;
								SC_sgi(GVAR_BOMBSTATUS,gBombStatus);	
								gAfterExplodeTimer = BOMB_AFTER_EXPLODE_TIMER;
								gSidePoints[0]++;
								UpdateSidePoints();
								break;
							}

						}// if (gStartTimer>5.0f)


						if (gMissionTime>0){
							gMissionTime -= info->elapsed_time;
							SRV_UpdateMissionTime(info->elapsed_time);

							if (gMissionTime<0.0f){
								gBombStatus = BOMB_STATUS_TIMEOUT;
								SC_sgi(GVAR_BOMBSTATUS,gBombStatus);	
								gAfterExplodeTimer = BOMB_AFTER_EXPLODE_TIMER;
								gSidePoints[1]++;
								UpdateSidePoints();
							}// if (gMissionTime<0.0f)

						}// gMissionTime

						if (gBombStatus != i){
							gBombStatus = i;
							if (gBombStatus==BOMB_STATUS_ACTIVE){
								gBombTimer = BOMB_TIMER;
								gUpdate_BombTimer = 0.0f;
							}
						}					
					break;

			}// switch(gBombStatus)

						
			SRV_CheckTimer(info->elapsed_time);
			
			break;

		case SC_NET_MES_CLIENT_TICK:

			gCLN_SidePoints[0] = SC_ggi(GVAR_SIDE0POINTS);
			gCLN_SidePoints[1] = SC_ggi(GVAR_SIDE1POINTS);

			SC_MP_SetSideStats(0,0,gCLN_SidePoints[0]);
			SC_MP_SetSideStats(1,0,gCLN_SidePoints[1]);


			gCLN_BombStatus = SC_ggi(GVAR_BOMBSTATUS);


			if (gCLN_MissionTimePrevID!=SC_ggi(GVAR_MISSIONTIME_UPDATE)){
				gCLN_MissionTimePrevID = SC_ggi(GVAR_MISSIONTIME_UPDATE);
				gCLN_MissionTime = SC_ggf(GVAR_MISSIONTIME);
			}
			else{
				gCLN_MissionTime -= info->elapsed_time;
			}


			for (i=0;i<2;i++){
				icon[i].color = 0xbbffffff;				
				icon[i].type = SC_HUD_MP_ICON_TYPE_NUMBER;
				icon[i].icon_id = 3*i;
				icon[i].value = gCLN_SidePoints[i];
			}

			i = 2;

			if ((gCLN_MissionTime>0.0f)
				&&((gCLN_BombStatus==BOMB_STATUS_INACTIVE)||(gCLN_BombStatus==BOMB_STATUS_ACTIVE))
				){
				icon[i].color = 0xbbffffff;
				icon[i].icon_id = 6;
				icon[i].value = (int)(gCLN_MissionTime+0.99f);					
				icon[i].type = SC_HUD_MP_ICON_TYPE_TIME;
				i++;
			}

			switch(gCLN_BombStatus){

				case BOMB_STATUS_STARTING:
				case BOMB_STATUS_INACTIVE:
				case BOMB_STATUS_EXPLODED:				
						active = FALSE;
						gRecv_BombTimer = gCLN_BombTimer = 0.0f;
						break;

				case BOMB_STATUS_ACTIVE:
					val = SC_ggf(GVAR_BOMBTIMER);
					if (val!=gRecv_BombTimer){
						gCLN_BombTimer = val;
						gRecv_BombTimer = val;
					}

					gCLN_BombTimer -= info->elapsed_time;

					icon[i].color = 0xffffffff;
					icon[i].icon_id = 10;
					if (gCLN_BombTimer>0) icon[i].value = (int)(gCLN_BombTimer+0.99f);
						else icon[i].value = 0;
					icon[i].type = SC_HUD_MP_ICON_TYPE_TIME;
					i++;

					active = TRUE;					
					break;
				default:
					active = FALSE;
					break;

			}// switch(gCLN_BombStatus)

			SC_DUMMY_Set_DoNotRenHier2(gC4nod,!active);
			
			SC_MP_SetIconHUD(icon,i);

			break;// SC_NET_MES_CLIENT_TICK


		case SC_NET_MES_LEVELPREINIT:
			SC_sgi(GVAR_MP_MISSIONTYPE,GVAR_MP_MISSIONTYPE_ATG);
			SC_sgi(GVAR_MP_MISSIONSUBTYPE,1);

			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;

			SC_MP_EnableBotsFromScene(FALSE);

			SC_MP_EnableC4weapon(TRUE);

			break;// SC_NET_MES_LEVELPREINIT

		case SC_NET_MES_LEVELINIT:

		#if _GE_VERSION_ >= 138
			g_FPV_BombZone = SC_MP_FpvMapSign_Load("g\\weapons\\Vvh_map\\icons\\MPIC_bombingzone.BES");
		#endif

			SC_MP_SRV_SetForceSide(0xffffffff);
			SC_MP_SetChooseValidSides(3);

			SC_MP_SRV_SetClassLimit(18,0);
			SC_MP_SRV_SetClassLimit(19,0);
			SC_MP_SRV_SetClassLimit(39,0);

			SC_MP_GetSRVsettings(&SRVset);

			for (i=0;i<6;i++){
				SC_MP_SRV_SetClassLimit(i+1,SRVset.atg_class_limit[i]);
				SC_MP_SRV_SetClassLimit(i+21,SRVset.atg_class_limit[i]);
			}// for (i)

			CLEAR(hudinfo);
			hudinfo.title = 1072;
			hudinfo.sort_by[0] = SC_HUD_MP_SORTBY_KILLS;
			hudinfo.sort_by[1] = SC_HUD_MP_SORTBY_DEATHS | SC_HUD_MP_SORT_DOWNUP;
			hudinfo.sort_by[2] = SC_HUD_MP_SORTBY_PINGS | SC_HUD_MP_SORT_DOWNUP;

			hudinfo.pl_mask = SC_HUD_MP_PL_MASK_CLASS | SC_HUD_MP_PL_MASK_KILLS | SC_HUD_MP_PL_MASK_DEATHS;
			hudinfo.use_sides = TRUE;
			hudinfo.side_name[0] = 1010;
			hudinfo.side_color[0] = 0x440000ff;
			hudinfo.side_name[1] = 1011;
			hudinfo.side_color[1] = 0x44ff0000;

			hudinfo.side_mask = SC_HUD_MP_SIDE_MASK_POINTS;
			
			SC_MP_HUD_SetTabInfo(&hudinfo);					

			SC_sgi(GVAR_BOMBSTATUS,BOMB_STATUS_STARTING);
			SC_MP_Gvar_SetSynchro(GVAR_BOMBSTATUS);	
			gRestartTimer = 0.0f;			

			gC4nod = SC_NOD_Get(NULL,"c4");
			if (gC4nod){
				SC_NOD_GetWorldPos(gC4nod,&gBombWorldPos);
				gBombWorldPos.z += 0.2f;

#if _GE_VERSION_ >= 138
				fpv_list[0].id = g_FPV_BombZone;
				fpv_list[0].color = 0xffffffff;
				fpv_list[0].pos = gBombWorldPos;
				fpv_list[0].scale = 1.0f;				

				SC_MP_FpvMapSign_Set(1,fpv_list);
#endif

			}
			else {
				SC_message("c4 not found");
				CLEAR(gBombWorldPos);
			}


			SC_MP_AllowStPwD(TRUE);
			SC_MP_AllowFriendlyFireOFF(TRUE);
			SC_MP_SetItemsNoDisappear(TRUE);

			if (info->param2){

				if (info->param1){
					// it's server		
					
					SC_MP_Gvar_SetSynchro(GVAR_SIDE0POINTS);
					SC_MP_Gvar_SetSynchro(GVAR_SIDE1POINTS);

					SC_MP_Gvar_SetSynchro(GVAR_BOMBTIMER);
					
					SC_MP_Gvar_SetSynchro(GVAR_MISSIONTIME);	
					SC_MP_Gvar_SetSynchro(GVAR_MISSIONTIME_UPDATE);

					
					UpdateSidePoints();
					
					CLEAR(gRecs);
				

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME_US,i);			
						if (SC_NET_FillRecover(&gRec[0][gRecs[0]],txt)) gRecs[0]++;					
					}					

#if _GE_VERSION_ >= 133
					i = REC_MAX - gRecs[0];
					SC_MP_GetRecovers(SC_MP_RESPAWN_ATG_US,&gRec[0][gRecs[0]],&i);
					gRecs[0] += i;
#endif

					SC_Log(3,"ATG UsBomb respawns us: %d",gRecs[0]);


					if (gRecs[0]==0) SC_message("no US recover place defined!");

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME_VC,i);			
						if (SC_NET_FillRecover(&gRec[1][gRecs[1]],txt)) gRecs[1]++;
					}					

#if _GE_VERSION_ >= 133
					i = REC_MAX - gRecs[1];
					SC_MP_GetRecovers(SC_MP_RESPAWN_ATG_VC,&gRec[1][gRecs[1]],&i);
					gRecs[1] += i;
#endif

					SC_Log(3,"ATG UsBomb respawns vc: %d",gRecs[0]);


					if (gRecs[1]==0) SC_message("no VC recover place defined!");					

					CLEAR(gRecTimer);

				}// if (info->param1)

			}//if (info->param2)


			break;// SC_NET_MES_LEVELINIT


		case SC_NET_MES_RENDERHUD:
					

			switch(SC_ggi(GVAR_BOMBSTATUS)){				
				case BOMB_STATUS_STARTING:text_id = 1076;break;													
				case BOMB_STATUS_EXPLODED:text_id = 1077;break;
				case BOMB_STATUS_US_KILLED:text_id = 1079;break;
				case BOMB_STATUS_VC_KILLED:text_id = 1080;break;
				case BOMB_STATUS_DRAW:text_id = 1082;break;				
				case BOMB_STATUS_TIMEOUT:text_id = 451;break;				
				default:text_id = 0;break;

			}

			if (text_id){										
				SC_GetScreenRes(&val,NULL);
				val -= SC_Fnt_GetWidthW(SC_Wtxt(text_id),1); 
				SC_Fnt_WriteW(val * 0.5f,15,SC_Wtxt(text_id),1,0xffffffff);
			}


			break;

		case SC_NET_MES_SERVER_RECOVER_TIME:

			SC_MP_SRV_GetAtgSettings(&atgset);
						
			if (((gBombStatus==BOMB_STATUS_INACTIVE)||(gBombStatus==BOMB_STATUS_ACTIVE))
					&&((gMissionTime+10.0f)<atgset.ATG_round_time)){
				info->fval1 = SC_NET_SERVER_RECTIME_ENDOFROUND;
			}
			else
			if (info->param2){
					info->fval1 = 0.1f;
			}
			else{
				// killed
				if (gInstantRecover) info->fval1 = 2.0f;
					else info->fval1 = -1.0f;
			}

			break;

		case SC_NET_MES_SERVER_RECOVER_PLACE:
			
			precov = (s_SC_MP_Recover*)info->param2;

			i = SC_MP_SRV_GetBestDMrecov(gRec[info->param1],gRecs[info->param1],gRecTimer[info->param1],NORECOV_TIME);
			
			gRecTimer[info->param1][i] = NORECOV_TIME;
			*precov = gRec[info->param1][i];
						
			break;
			

		case SC_NET_MES_SERVER_KILL:


			break;// SC_NET_MES_SERVER_KILL

		case SC_NET_MES_MESSAGE:

			if ((info->param1==0)&&(info->param2==0)){

				SC_P_GetInfo(SC_PC_Get(),&plinfo);

				if (plinfo.side){				
					SC_sgi(GVAR_BOMBSTATUS,BOMB_STATUS_INACTIVE);
				}
				else {
					SC_sgi(GVAR_BOMBSTATUS,BOMB_STATUS_ACTIVE);
				}
						
			}// if ((info->param1==0)&&(info->param2==0))

			break;


		case SC_NET_MES_RESTARTMAP:

			CLEAR(gSidePoints);			
			UpdateSidePoints();


			gBombStatus = BOMB_STATUS_STARTING;
			gBombTimer = 0.0f;
			gAfterExplodeTimer = 0.0f;


			gUpdate_BombTimer = 0.0f;
			gRecv_BombTimer = 0.0f;
			

			gStartTimer = 0.0f;
			gRestartTimer = 0.0f;

			gInstantRecover = TRUE;

			gTime = 0;

			SRV_InstantRecover(TRUE);	
			SC_MP_SRV_ClearPlsStats();

			SC_MP_SRV_InitGameAfterInactive();
			SC_MP_RecoverAllNoAiPlayers();			

			break;// SC_NET_MES_RESTARTMAP

		case SC_NET_MES_RULESCHANGED:			
			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;
			break;

					
	}// switch(info->message)
	

	return 1;

}// int ScriptMain(void)
