/*
	Eric multiplayer script - CTR
*/

#include <inc\sc_global.h>
#include <inc\sc_def.h>


#define RECOVER_TIME	5.0f		// time to recover player after killed
#define NORECOV_TIME	3.0f		// disable time of recoverplace after recovering someone there

#define REC_WPNAME		"DM%d"
#define REC_MAX			64

#define RADIO_WPNAME	"Radio%d"
#define RADIO_MAX		16


dword gRecs = 0;
s_SC_MP_Recover gRec[REC_MAX];
float gRecTimer[REC_MAX];

dword gRadioRecs = 0;
s_SC_MP_Recover gRadioRec[RADIO_MAX];



#define GVAR_PHASE				500

#define PHASE_BEGIN				1
#define PHASE_RUNS				2



#define RADIO_COLOR				0xff00ff
#define RADIO_ITEMTYPE			60
#define RADIO_WEAPTYPE			60
#define RADIO_TIMER				5
#define RADIO_ON_PLACE_MAX_TIME	59

dword gPhase = PHASE_BEGIN;
float gRadioTimer = 0.0f;
float gRadioOnPlace = 0.0f;

dword gPlayersConnected = 0;


dword gEndRule;
dword gEndValue;
float gTime;


BOOL SRV_CheckEndRule(float time){
	int points;

	switch(gEndRule){
		case SC_MP_ENDRULE_TIME:

			if (gPlayersConnected>0) gTime += time;
			SC_MP_EndRule_SetTimeLeft(gTime,gPlayersConnected>0);

			if (gTime>gEndValue){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		case SC_MP_ENDRULE_POINTS:

			if (SC_MP_GetMaxPointsPl(&points)){

				if (points>=gEndValue){
					SC_MP_LoadNextMap();
					return TRUE;
				}
			}

			break;

		default:
			SC_message("EndRule unsopported: %d",gEndRule);
			break;

	}// switch(gEndRule)

	return FALSE;

}// void SRV_CheckEndRule(float time)


dword GetPlWithRadio(void){
	s_SC_MP_EnumPlayers enum_pl[64];
	dword i,k,pls;
	s_SC_P_Create plcreate;

	pls = 64;
	if (!SC_MP_EnumPlayers(enum_pl,&pls,SC_MP_ENUMPLAYER_SIDE_ALL)) SC_message("enum failed");

	
	k = 0;
	for (i=0;i<pls;i++)
		if (enum_pl[i].status==SC_MP_P_STATUS_INGAME){
		
			if (SC_P_GetWeapons(enum_pl[i].id,&plcreate)){
				if (plcreate.weap_main2==RADIO_WEAPTYPE) return enum_pl[i].id;
			}

		}


	return 0;

}// dword GetPlWithRadio(void)

int ScriptMain(s_SC_NET_info *info){
	char txt[32];
	dword i,k,pls;
	s_SC_MP_Recover *precov;
	s_SC_MP_hud hudinfo;
	s_SC_MP_EnumPlayers enum_pl[64];
	c_Vector3 vec;
	dword pl_with_radio,radio_netid;
	s_SC_MP_SRV_settings SRVset;


	switch(info->message){
		
		case SC_NET_MES_SERVER_TICK:			

			if (SRV_CheckEndRule(info->elapsed_time)) break;

			for (i=0;i<gRecs;i++)
				gRecTimer[i] -= info->elapsed_time;


			pls = 64;
			if (!SC_MP_EnumPlayers(enum_pl,&pls,SC_MP_ENUMPLAYER_SIDE_ALL)) SC_message("enum failed");

			gPlayersConnected = pls;

			k = 0;
			for (i=0;i<pls;i++)
				if (enum_pl[i].status==SC_MP_P_STATUS_INGAME) k++;


			switch(gPhase){

				case PHASE_BEGIN:

					if (k>1){					
						gPhase = PHASE_RUNS;
						SC_Item_Create(RADIO_ITEMTYPE,&gRadioRec[rand()%gRadioRecs].pos);
						//SC_message("radio in scene");
					}// if (k>1)

					break;

				case PHASE_RUNS:					
					gRadioTimer -= info->elapsed_time;

					if (gRadioTimer<0.0f){

						gRadioTimer += RADIO_TIMER;

						pl_with_radio = GetPlWithRadio();

						if (pl_with_radio){
							gRadioOnPlace = 0;
							SC_P_MP_AddPoints(pl_with_radio,1);
						}
						else{

							radio_netid = SC_Item_Find(RADIO_ITEMTYPE);
							if (!radio_netid){
								SC_Item_Create(RADIO_ITEMTYPE,&gRadioRec[rand()%gRadioRecs].pos);
							}
							else{

								gRadioOnPlace += RADIO_TIMER;
								if (gRadioOnPlace>RADIO_ON_PLACE_MAX_TIME){
									gRadioOnPlace = 0;
									
									SC_SRV_Item_Release(radio_netid);
									SC_Item_Create(RADIO_ITEMTYPE,&gRadioRec[rand()%gRadioRecs].pos);

								}// if (gRadioOnPlace>RADIO_ON_PLACE_MAX_TIME)

							}

						}// else if (pl_with_radio)
					
					}// if (gRadioTimer<0.0f)
						
					break;

			}// switch(gPhase)

			//SRV_CheckSet();

			break;// SC_NET_MES_SERVER_TICK

		case SC_NET_MES_CLIENT_TICK:

			pl_with_radio = GetPlWithRadio();
			radio_netid = SC_Item_Find(RADIO_ITEMTYPE);

			if ((pl_with_radio)&&(pl_with_radio != SC_PC_Get())){
				SC_HUD_RadarShowPlayer(pl_with_radio,RADIO_COLOR);
				SC_HUD_RadarShowPos(NULL,0);
			}
			else
			if (radio_netid){
				SC_HUD_RadarShowPlayer(0,0);					
				SC_Item_GetPos(radio_netid,&vec);
				SC_HUD_RadarShowPos(&vec,RADIO_COLOR);			
			}
			else{
				SC_HUD_RadarShowPlayer(0,0);
				SC_HUD_RadarShowPos(NULL,0);
			}

			break;// SC_NET_MES_CLIENT_TICK


		case SC_NET_MES_LEVELPREINIT:
			SC_sgi(GVAR_MP_MISSIONTYPE,GVAR_MP_MISSIONTYPE_CTR);

			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;

			SC_MP_EnableBotsFromScene(FALSE);

			break;// SC_NET_MES_LEVELPREINIT

		case SC_NET_MES_LEVELINIT:
			
			SC_MP_SRV_SetForceSide(0xffffffff);
			SC_MP_SetChooseValidSides(3);


			SC_HUD_DisableRadar(TRUE);
			
			SC_MP_SRV_SetClassLimitsForDM();

			CLEAR(hudinfo);
			hudinfo.title = 1083;
			
			hudinfo.sort_by[0] = SC_HUD_MP_SORTBY_POINTS;
			hudinfo.sort_by[1] = SC_HUD_MP_SORTBY_KILLS;
			hudinfo.sort_by[2] = SC_HUD_MP_SORTBY_DEATHS | SC_HUD_MP_SORT_DOWNUP;
			hudinfo.sort_by[3] = SC_HUD_MP_SORTBY_PINGS | SC_HUD_MP_SORT_DOWNUP;

			hudinfo.pl_mask = SC_HUD_MP_PL_MASK_POINTS | SC_HUD_MP_PL_MASK_KILLS | SC_HUD_MP_PL_MASK_DEATHS;
			hudinfo.use_sides = 0;

			SC_MP_HUD_SetTabInfo(&hudinfo);

			SC_MP_AllowStPwD(FALSE);
			SC_MP_AllowFriendlyFireOFF(FALSE);
			SC_MP_SetItemsNoDisappear(FALSE);

			if (info->param2){

				SC_Item_Preload(60);

				if (info->param1){
					// it's server		
					
					SC_MP_Gvar_SetSynchro(GVAR_PHASE);					

									
					SC_MP_GetSRVsettings(&SRVset);
					SC_MP_SRV_InitWeaponsRecovery((float)SRVset.dm_weap_resp_time);

					gRecs = 0;

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME,i);			
						if (SC_NET_FillRecover(&gRec[gRecs],txt)) gRecs++;
					}					

					if (gRecs==0) SC_message("no recover place defined!");

					gRadioRecs = 0;

					for (i=0;i<RADIO_MAX;i++){		
						sprintf(txt,RADIO_WPNAME,i);			
						if (SC_NET_FillRecover(&gRadioRec[gRadioRecs],txt)) gRadioRecs++;
					}					
				
					if (gRadioRecs==0) SC_message("no radio recover place defined!");

					CLEAR(gRecTimer);

				}// if (info->param1)

			}//if (info->param2)


			break;// SC_NET_MES_LEVELINIT


		case SC_NET_MES_RENDERHUD:

			break;

		case SC_NET_MES_SERVER_RECOVER_TIME:

			if (info->param2){
					info->fval1 = 0.1f;
			}
			else{
				// killed
				info->fval1 = RECOVER_TIME;
			}

			break;

		case SC_NET_MES_SERVER_RECOVER_PLACE:
			
			precov = (s_SC_MP_Recover*)info->param2;

			i = SC_MP_SRV_GetBestDMrecov(gRec,gRecs,gRecTimer,NORECOV_TIME);
			
			gRecTimer[i] = NORECOV_TIME;
			*precov = gRec[i];
						
			break;
			

	}// switch(info->message)
	

	return 1;

}// int ScriptMain(void)
