/*
	Eric multiplayer script - LMS
*/

#include <inc\sc_global.h>
#include <inc\sc_def.h>


#define NORECOV_TIME	3.0f		// disable time of recoverplace after recovering someone there

#define REC_WPNAME		"DM%d"
#define REC_MAX			64


#define GP_WAITING_FOR_2PLS				0
#define GP_DM							1
#define GP_RAMBO_START					2
#define GP_RAMBO						3


#define TIME_LIMIT0						120
#define TIME_LIMIT1						120

#define TIME_LIMIT_UPDATE_INTERVAL		(10.0f)

#define GVAR_GAMEPHASE					500
#define GVAR_RAMBO_PL					501
#define GVAR_RESTART					502
#define GVAR_UPDATE_TIMELIMIT			503
#define GVAR_CLN_STATUS					504


#define CLN_ST_WAITING_FOR_PLAYERS		0
#define CLN_ST_STARTING_DM				1
#define CLN_ST_PLAYING_DM				2
#define CLN_ST_DM_TIMEDONE				3
#define CLN_ST_STARTING_RAMBO			4
#define CLN_ST_PLAYING_RAMBO			5
#define CLN_ST_RAMBO_WIN				6
#define CLN_ST_RAMBO_KILLED				7

dword gRecs = 0;
s_SC_MP_Recover gRec[REC_MAX];
float gRecTimer[REC_MAX];


dword gGamePhase = GP_WAITING_FOR_2PLS;
dword gRambo_pl_handle;
float gGamePhaseTimer;

dword gGamePhase0counter = 0;

float gGameTimeLimit;
float gGameTimeLimit_Update;

float gCLN_GameTimeLimitLastUpdate;
float gCLN_GameTimeLimit;

dword gCLN_GamePhase = GP_WAITING_FOR_2PLS;


dword gRestart_type;
float gRestart_timer = 0.0f;

dword gCLN_Restart_type;
dword gCLN_status =0;
dword gSRV_CLNstatus_send = 0;



dword gEndRule;
dword gEndValue;
float gTime;


BOOL SRV_CheckEndRule(float time){
	int points;

	switch(gEndRule){
		case SC_MP_ENDRULE_TIME:
		
			if (gGamePhase!=GP_WAITING_FOR_2PLS) gTime += time;
			SC_MP_EndRule_SetTimeLeft(gTime,gGamePhase!=GP_WAITING_FOR_2PLS);

			if (gTime>gEndValue){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		case SC_MP_ENDRULE_POINTS:

			if (SC_MP_GetMaxPointsPl(&points)){

				if (points>=gEndValue){
					SC_MP_LoadNextMap();
					return TRUE;
				}
			}

			break;

		default:
			SC_message("EndRule unsopported: %d",gEndRule);
			break;

	}// switch(gEndRule)

	return FALSE;

}// void SRV_CheckEndRule(float time)


void UpdateRambo(dword new_rambo){
	dword pl;

	if (gRambo_pl_handle){
		pl = SC_MP_GetPlofHandle(gRambo_pl_handle);
		if (pl)
			SC_MP_SRV_P_SetObtainedDamageMult(pl,1.0f);
	}

	gRambo_pl_handle = new_rambo;

	SC_sgi(GVAR_RAMBO_PL,gRambo_pl_handle);

}// void UpdateRambo(void)

void UpdateTimeLimit(float frame_time){

	if (frame_time>0.0f){
		gGameTimeLimit -= frame_time;
		gGameTimeLimit_Update -= frame_time;
	}
	else gGameTimeLimit_Update = -1.0f;

	if (gGameTimeLimit_Update<=0.0f){
		SC_sgf(GVAR_UPDATE_TIMELIMIT,gGameTimeLimit);
		gGameTimeLimit_Update = TIME_LIMIT_UPDATE_INTERVAL;
	}


}// void UpdateTimeLimit(float frame_time)

void UpdateCLNstatus(dword val){

	if (val!=gSRV_CLNstatus_send){
		gSRV_CLNstatus_send = val;
		SC_sgi(GVAR_CLN_STATUS,val);
	}
	
}// void UpdateCLNstatus(dword val)

int ScriptMain(s_SC_NET_info *info){
	char txt[128];
	ushort wtxt[128],wtxt2[64];
	dword i,pls,k,enum_pl_valid,pl,text_id;
	s_SC_MP_Recover *precov;
	s_SC_MP_EnumPlayers enum_pl[64];
	BOOL rambo_valid;
	char *plname;
	s_SC_MP_hud hudinfo;
	s_SC_P_getinfo plinfo;
	float itime,pl_dist;
	s_SC_HUD_MP_icon icon;
	s_SC_MP_SRV_settings SRVset;

	switch(info->message){
		
		case SC_NET_MES_SERVER_TICK:			

			if (SRV_CheckEndRule(info->elapsed_time)) break;

			for (i=0;i<gRecs;i++)
				gRecTimer[i] -= info->elapsed_time;

			i = SC_ggi(GVAR_RESTART);
			if (i!=gRestart_type) SC_sgi(GVAR_RESTART,gRestart_type);
				
			if (gRestart_timer>0.0f){

				SC_Osi("Restart: %2.2f",gRestart_timer);
				gRestart_timer -= info->elapsed_time;
				if (gRestart_timer>0.0f) break;
				
				switch(gRestart_type){

					case GP_WAITING_FOR_2PLS:
						SC_MP_RestartMission();
						gGamePhase = GP_WAITING_FOR_2PLS;
						gGamePhase0counter = 0;
						SC_sgi(GVAR_GAMEPHASE,gGamePhase);
						break;

					case GP_RAMBO_START:
						gGamePhase = GP_RAMBO_START;
						SC_sgi(GVAR_GAMEPHASE,gGamePhase);

						gGamePhaseTimer = 10.0f;
						SC_MP_RestartMission();
						break;

				}// switch(gRestart_type)

				gRestart_type = 0;

				break;
				
			}

			pls = 64;
			if (!SC_MP_EnumPlayers(enum_pl,&pls,SC_MP_ENUMPLAYER_SIDE_ALL)) SC_message("enum failed");

			rambo_valid = FALSE;
			if (gRambo_pl_handle)
				pl = SC_MP_GetPlofHandle(gRambo_pl_handle);
			else pl = 0;

			k = 0;
			for (i=0;i<pls;i++)
				if (enum_pl[i].status==SC_MP_P_STATUS_INGAME){
					if ((pl)&&(pl==enum_pl[i].id)) rambo_valid = TRUE;					
					enum_pl_valid = i;
					k++;
				}

			// update Rambo strength
			if (rambo_valid){					
				SC_MP_SRV_P_SetObtainedDamageMult(pl,1.4f/(float)(pls-1));
			}


			//SC_Osi("ingame pls: %d  rambo: %d [%d]",k,gRambo_pl,rambo_valid);

			switch(gGamePhase){

				case GP_WAITING_FOR_2PLS:					

					if (k>1) gGamePhase0counter++;

					if (gGamePhase0counter>2){						
						gGameTimeLimit = TIME_LIMIT0;						
						UpdateTimeLimit(-1.0f);
						gGamePhase = GP_DM;
						SC_sgi(GVAR_GAMEPHASE,gGamePhase);
					}

					UpdateCLNstatus(CLN_ST_WAITING_FOR_PLAYERS);

					break;// 0 switch(gGamePhase)

				case GP_DM:

					UpdateCLNstatus(CLN_ST_PLAYING_DM);

					UpdateTimeLimit(info->elapsed_time);

					//SC_Osi("DM: %2.2f",gGameTimeLimit);

					if (k==0){
						UpdateCLNstatus(CLN_ST_STARTING_DM);
					}
					else
					if (gGameTimeLimit<=0.0f){						
						k = 0;
						UpdateCLNstatus(CLN_ST_DM_TIMEDONE);
					}

					switch(k){

						case 0:													
							gRestart_type = GP_WAITING_FOR_2PLS;
							gRestart_timer = 6.0f;
							break;
						case 1:														

							UpdateRambo(SC_MP_GetHandleofPl(enum_pl[enum_pl_valid].id));

							UpdateCLNstatus(CLN_ST_STARTING_RAMBO);
							gRestart_type = GP_RAMBO_START;
							gRestart_timer = 6.0f;

							pl = SC_MP_GetPlofHandle(gRambo_pl_handle);
							if (pl)
								SC_P_MP_AddPoints(pl,2);
							break;

					}// switch(k)

					break;

				case GP_RAMBO_START:					
					
					gGamePhaseTimer -= info->elapsed_time;
					if (gGamePhaseTimer<0.0f){						

						UpdateCLNstatus(CLN_ST_STARTING_DM);

						gRestart_type = GP_WAITING_FOR_2PLS;
						gRestart_timer = 6.0f;												
						UpdateRambo(0);
						break;
					}
					
					if ((k>1)&&(rambo_valid)){
						gGamePhase = GP_RAMBO;
						SC_sgi(GVAR_GAMEPHASE,gGamePhase);
						gGameTimeLimit = TIME_LIMIT1;
						UpdateTimeLimit(-1.0f);
					}
					else break;
					
				case GP_RAMBO:

					UpdateCLNstatus(CLN_ST_PLAYING_RAMBO);

					UpdateTimeLimit(info->elapsed_time);
					if (gGameTimeLimit<=0.0f) rambo_valid = FALSE;

					if (rambo_valid){

						if (k==1){
							// rambo wins				
							UpdateCLNstatus(CLN_ST_RAMBO_WIN);

							gRestart_type = GP_RAMBO_START;
							gRestart_timer = 6.0f;
							gGamePhaseTimer = 10.0f;							
							pl = SC_MP_GetPlofHandle(gRambo_pl_handle);
							SC_P_MP_AddPoints(pl,3);
						}
					}
					else{
						// rambo killed						
						
						UpdateRambo(0);
						UpdateCLNstatus(CLN_ST_RAMBO_KILLED);
						
						gRestart_type = GP_WAITING_FOR_2PLS;
						gRestart_timer = 6.0f;						

					}


					break;

			}// switch(gGamePhase)

			break;
			
		case SC_NET_MES_CLIENT_TICK:
			
			gCLN_status = SC_ggi(GVAR_CLN_STATUS);

			itime = SC_ggf(GVAR_UPDATE_TIMELIMIT);

			if (itime!=gCLN_GameTimeLimitLastUpdate){
				gCLN_GameTimeLimitLastUpdate = itime;
				gCLN_GameTimeLimit = itime;
			}

			gCLN_GameTimeLimit -= info->elapsed_time;
			if (gCLN_GameTimeLimit<0.0f) gCLN_GameTimeLimit = 0.0f;

			i = SC_ggi(GVAR_GAMEPHASE);

			k = SC_ggi(GVAR_RAMBO_PL);
			k = SC_MP_GetPlofHandle(k);

			if (i!=gCLN_GamePhase){				

				switch(i){

					case GP_DM:
						SC_GameInfo(1053,NULL);
						gCLN_GamePhase = i;

						break;

					case GP_RAMBO:
						
						if (k){	
							
							if (k==SC_PC_Get()){								
								SC_GameInfo(1055,NULL);
								// give machinegun to rambo
								SC_P_GetInfo(k,&plinfo);
								if (plinfo.side==1) SC_P_ChangeWeapon(k,2,18);
									else SC_P_ChangeWeapon(k,2,17);

								SC_P_ChangeWeapon(k,4,59);

								SC_P_SetSelWeapon(k,2);

							}
							else{													
								swprintf(wtxt,SC_AnsiToUni("%s %S !",wtxt2),SC_Wtxt(1054),SC_P_GetName(k));
								SC_GameInfoW(wtxt);								
							}

							gCLN_GamePhase = i;
						}// if (k)

						break;
					default:
						gCLN_GamePhase = i;
						break;

				}// switch(gCLN_GamePhase)

			}// if (i!=gCLN_GamePhase)


			SC_MP_HUD_SelectPl(k,0x77ff0000);

			if (k==SC_PC_Get()) SC_HUD_RadarShowPlayer(NULL,0);
				else SC_HUD_RadarShowPlayer(k,0xff0000);
			
			i = SC_ggi(GVAR_RESTART);
			if (i!=gCLN_Restart_type){
				
				switch(i){

					case GP_WAITING_FOR_2PLS:

						SC_GameInfo(1056,NULL);
						gCLN_Restart_type = i;
						break;

					case GP_RAMBO_START:

						if (k){	
							
							if (k==SC_PC_Get()) SC_GameInfo(1058,NULL);
							else{													
								swprintf(wtxt,SC_AnsiToUni("%s %S !",wtxt2),SC_Wtxt(1057),SC_P_GetName(k));
								SC_GameInfoW(wtxt);								
							}

							gCLN_Restart_type = i;
						}// if (k)

						break;
					default:
						gCLN_Restart_type = i;
						break;

				}// switch(gRestart_type)
			}// restart type changed

			

			switch(gCLN_status){			
				case CLN_ST_PLAYING_DM:
				case CLN_ST_PLAYING_RAMBO:

					icon.color = 0xffffffff;
					icon.icon_id = 6;
					if (gCLN_GameTimeLimit>0) icon.value = (int)(gCLN_GameTimeLimit+0.99f);
						else icon.value = 0;
					icon.type = SC_HUD_MP_ICON_TYPE_TIME;
					i = 1;
					break;

				default:i = 0;;break;
			}// switch(gCLN_status)


			SC_MP_SetIconHUD(&icon,i);

			break;// SC_NET_MES_CLIENT_TICK


		case SC_NET_MES_LEVELPREINIT:
			SC_sgi(GVAR_MP_MISSIONTYPE,GVAR_MP_MISSIONTYPE_LMS);

			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;

			SC_MP_EnableBotsFromScene(FALSE);

			break;// SC_NET_MES_LEVELPREINIT

		case SC_NET_MES_LEVELINIT:
			
			SC_HUD_DisableRadar(TRUE);

			SC_MP_SRV_SetForceSide(0xffffffff);
			SC_MP_SetChooseValidSides(3);


			SC_MP_SRV_SetClassLimitsForDM();


			CLEAR(hudinfo);
			hudinfo.title = 1052;

			hudinfo.sort_by[0] = SC_HUD_MP_SORTBY_POINTS;
			hudinfo.sort_by[1] = SC_HUD_MP_SORTBY_KILLS;
			hudinfo.sort_by[2] = SC_HUD_MP_SORTBY_DEATHS | SC_HUD_MP_SORT_DOWNUP;
			hudinfo.sort_by[3] = SC_HUD_MP_SORTBY_PINGS | SC_HUD_MP_SORT_DOWNUP;

			hudinfo.pl_mask = SC_HUD_MP_PL_MASK_POINTS | SC_HUD_MP_PL_MASK_KILLS | SC_HUD_MP_PL_MASK_DEATHS;
			hudinfo.use_sides = 0;

			SC_MP_HUD_SetTabInfo(&hudinfo);

			SC_MP_AllowStPwD(FALSE);
			SC_MP_AllowFriendlyFireOFF(FALSE);
			SC_MP_SetItemsNoDisappear(FALSE);

			if (info->param2){

				if (info->param1){
					// it's server
					
					SC_MP_Gvar_SetSynchro(GVAR_GAMEPHASE);
					SC_sgi(GVAR_GAMEPHASE,0);

					SC_MP_Gvar_SetSynchro(GVAR_RAMBO_PL);
					SC_sgi(GVAR_RAMBO_PL,0);

					SC_MP_Gvar_SetSynchro(GVAR_RESTART);
					SC_sgi(GVAR_RESTART,0);

					SC_MP_Gvar_SetSynchro(GVAR_UPDATE_TIMELIMIT);
					SC_sgi(GVAR_UPDATE_TIMELIMIT,0);					

					
					SC_MP_Gvar_SetSynchro(GVAR_CLN_STATUS);
					SC_sgi(GVAR_CLN_STATUS,0);					


					SC_MP_GetSRVsettings(&SRVset);
					SC_MP_SRV_InitWeaponsRecovery((float)SRVset.dm_weap_resp_time);

					gRecs = 0;

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME,i);			
						if (SC_NET_FillRecover(&gRec[gRecs],txt)) gRecs++;
					}					


					if (gRecs==0) SC_message("no recover place defined!");

					CLEAR(gRecTimer);

				}// if (info->param1)

			}//if (info->param2)


			break;// SC_NET_MES_LEVELINIT


		case SC_NET_MES_RENDERHUD:

						
			switch(gCLN_status){
			
				case CLN_ST_WAITING_FOR_PLAYERS:text_id = 1059;break;
				case CLN_ST_STARTING_DM:text_id = 1060;break;													
				case CLN_ST_DM_TIMEDONE:text_id = 1062;break;									
				case CLN_ST_STARTING_RAMBO:text_id = 1063;break;													
				case CLN_ST_RAMBO_WIN:text_id = 1065;break;									
				case CLN_ST_RAMBO_KILLED:text_id = 1066;break;									
				default:text_id = 0;break;
			}// switch(gCLN_status)

			if (text_id){
							
				SC_GetScreenRes(&pl_dist,NULL);

				pl_dist -= SC_Fnt_GetWidthW(SC_Wtxt(text_id),1); 

				SC_Fnt_WriteW(pl_dist * 0.5f,15,SC_Wtxt(text_id),1,0xffffffff);
			
			}// (txt[0])

			break;

		case SC_NET_MES_SERVER_RECOVER_TIME:

			if (info->param2){
					info->fval1 = 0.1f;
			}
			else{
				// killed
				info->fval1 = -1.0f;
			}

			break;

		case SC_NET_MES_SERVER_RECOVER_PLACE:
			
			precov = (s_SC_MP_Recover*)info->param2;

			i = SC_MP_SRV_GetBestDMrecov(gRec,gRecs,gRecTimer,NORECOV_TIME);
			
			gRecTimer[i] = NORECOV_TIME;
			*precov = gRec[i];
						
			break;

		case SC_NET_MES_SERVER_KILL:

			pl = SC_MP_GetPlofHandle(gRambo_pl_handle);
			
			if (info->param1==pl){
				if (info->param1==info->param2) SC_P_MP_AddPoints(pl,-1);
				else if (info->param2) SC_P_MP_AddPoints(info->param2,1);
			}
			break;

		case SC_NET_MES_RESTARTMAP:

			gGamePhase = GP_WAITING_FOR_2PLS;
			UpdateRambo(0);
			gGamePhaseTimer = 0.0f;

			gTime = 0.0f;

			gGamePhase0counter = 0;

			gGameTimeLimit = 0;
			gGameTimeLimit_Update = 0;

			gCLN_GameTimeLimitLastUpdate = 0;
			gCLN_GameTimeLimit = 0;			


			gRestart_type = 0;
			gRestart_timer = 0.0f;

			gSRV_CLNstatus_send = 0;


			SC_MP_SRV_ClearPlsStats();

			SC_MP_SRV_InitGameAfterInactive();
			SC_MP_RecoverAllNoAiPlayers();			

			break;// SC_NET_MES_RESTARTMAP

		case SC_NET_MES_RULESCHANGED:			
			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;
			break;
						
				
	}// switch(info->message)
	

	return 1;

}// int ScriptMain(void)
