/*
	Eric multiplayer script - Real War
*/

#include <inc\sc_global.h>
#include <inc\sc_def.h>


#define NORECOV_TIME			8.0f		// disable time of recoverplace after recovering someone there


#define REC_WPNAME_US	"USSpawn_rw_%d"
#define REC_WPNAME_VC	"VCSpawn_rw_%d"
#define REC_MAX			64

#define FLAGS_MAX		6

#define FLAG_US			0
#define FLAG_VC			1
#define FLAG_NEUTRAL	2


#define PHASE_NONE		0
#define PHASE_RUNS		1
#define PHASE_USWIN		2
#define PHASE_VCWIN		3

#define GVAR_SIDE0POINTS				500
#define GVAR_SIDE1POINTS				501

#define GVAR_FLAGSTATUS					510
#define GVAR_PHASE						520
#define GVAR_INFO						530
#define GVAR_INFOPLHANDLE				540
#define GVAR_LAST						550

#define TOWIN_OCCUPY_TIME				5.0f

#define INFO_FL_NONE				0
#define INFO_FL_CAPT_US				1
#define INFO_FL_CAPT_VC				2

				
dword gInfo[FLAGS_MAX] = {INFO_FL_NONE,INFO_FL_NONE,INFO_FL_NONE,INFO_FL_NONE,INFO_FL_NONE,INFO_FL_NONE};
dword gSend_Info[FLAGS_MAX];
dword gCLN_Info[FLAGS_MAX];

dword gInfoPlHandle[FLAGS_MAX] = {0,0,0,0,0,0};
dword gSend_InfoPlHandle[FLAGS_MAX];
dword gCLN_InfoPlHandle[FLAGS_MAX];


float gCLN_HelpInfo_timer = 0.0f;
ushort gCLN_HelpInfo[256];

float gMission_afterstart_time = 0.0f;

float gMission_starting_timer = 0.0f;

dword gRecs[2] = {0,0};
s_SC_MP_Recover gRec[2][REC_MAX];
float gRecTimer[2][REC_MAX];


dword gRecsFl[FLAGS_MAX];
s_SC_MP_Recover gRecFl[FLAGS_MAX][REC_MAX];
float gRecTimerFl[FLAGS_MAX][REC_MAX];

#if _GE_VERSION_ >= 138
dword g_FPV_UsFlag = 0;
dword g_FPV_VcFlag = 0;
dword g_FPV_NeFlag = 0;
#endif


float gNextRecover = 0.0f;

int gSidePoints[2] = {0,0};

int gCLN_SidePoints[2];

dword gPhase = PHASE_NONE;
float gPhaseTime = 0.0f;

dword gEndRule;
dword gEndValue;
float gTime;


float gOccupyTime = TOWIN_OCCUPY_TIME;

dword gRespawn_id[FLAGS_MAX] = {SC_MP_RESPAWN_WA,SC_MP_RESPAWN_WB,SC_MP_RESPAWN_WC,SC_MP_RESPAWN_WD,SC_MP_RESPAWN_WE,SC_MP_RESPAWN_WF};


BOOL SRV_CheckEndRule(float time){

	switch(gEndRule){
		case SC_MP_ENDRULE_TIME:

			if (gPhase!=PHASE_NONE) gTime += time;
			SC_MP_EndRule_SetTimeLeft(gTime,gPhase!=PHASE_NONE);

			if (gTime>gEndValue){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		case SC_MP_ENDRULE_POINTS:

			if ((gSidePoints[0]>=gEndValue)||(gSidePoints[1]>=gEndValue)){
				SC_MP_LoadNextMap();
				return TRUE;
			}

			break;

		default:
			SC_message("EndRule unsopported: %d",gEndRule);
			break;

	}// switch(gEndRule)

	return FALSE;

}// void SRV_CheckEndRule(float time)


float GetRecovTime(void){
	float val;
	val = SC_ggf(400);
	if (val==0) val = 30;
	return val;
}

float GetRecovLimitTime(void){
	float val;
	val = SC_ggf(401);
	if (val==0) val = 10;
	return val;
}


void UpdateSidePoints(void){
	SC_sgi(GVAR_SIDE0POINTS,gSidePoints[0]);
	SC_sgi(GVAR_SIDE1POINTS,gSidePoints[1]);
}// void UpdateSidePoints(void)


void *gFlagNod[FLAGS_MAX][3];
dword gFlagIndex[FLAGS_MAX];
c_Vector3 gOrigFlagPos[FLAGS_MAX];
dword gFlagPhase[FLAGS_MAX] = {FLAG_NEUTRAL,FLAG_NEUTRAL,FLAG_NEUTRAL,FLAG_NEUTRAL,FLAG_NEUTRAL,FLAG_NEUTRAL};		// FLAG_PH_


dword gSend_FlagPhase[FLAGS_MAX];

dword gCLN_FlagPhase[FLAGS_MAX];

dword gFlags = 0;


void SRV_ChechSendStatus(void){
	dword i;

	for (i=0;i<gFlags;i++){

		if (gFlagPhase[i]!=gSend_FlagPhase[i]){
			gSend_FlagPhase[i] = gFlagPhase[i];
			SC_sgi(GVAR_FLAGSTATUS+i,gSend_FlagPhase[i]);
		}

		if (gSend_Info[i]!=gInfo[i]){
			gSend_Info[i] = gInfo[i];
			SC_sgi(GVAR_INFO+i,gSend_Info[i]);
		}// if (gInfo[i]!=gSend_Info[i])

		if (gSend_InfoPlHandle[i]!=gInfoPlHandle[i]){
			gSend_InfoPlHandle[i] = gInfoPlHandle[i];
			SC_sgi(GVAR_INFOPLHANDLE+i,gSend_InfoPlHandle[i]);
		}// if (gInfo[i]!=gSend_Info[i])

	}// for (i)

}// void SRV_ChechSendStatus(void)



void ResetMission(void){
	dword i;

	for (i=0;i<FLAGS_MAX;i++){
		gFlagPhase[i] = FLAG_NEUTRAL;			
		gInfo[i]  = INFO_FL_NONE;
		gInfoPlHandle[i] = 0;
	}// for (i)

}// void ResetMission(void)



void Check_ABL(dword pl_handle){
	int val;
	dword to_change;
	s_SC_P_getinfo info;

	if (!SC_MP_SRV_GetAutoTeamBalance()) return;

	val = SC_MP_SRV_GetTeamsNrDifference(TRUE);

	if ((val<3)&&(val>-3)) return;	// no big difference

	SC_P_GetInfo(pl_handle,&info);	

	if ((info.side==0)&&(val>0)) to_change = 1;
	else
	if ((info.side==1)&&(val<0)) to_change = 0;
	else
		return;

	SC_MP_SRV_P_SetSideClass(pl_handle,to_change,1 + 20*to_change);

}// void Check_ABL(dword pl_handle)



int ScriptMain(s_SC_NET_info *info){
	char txt[128],*itxt;
	ushort wtxt[128],wtxt2[64],*iwtxt;
	dword i,j,pl_id,k,txt_id,middle;
	s_SC_MP_Recover *precov;
	s_SC_MP_hud hudinfo;
	s_SC_P_getinfo plinfo;
	void *nod;
	c_Vector3 vec,vec2;
	BOOL valid;
	float pl_dist,yres;
	s_SC_HUD_MP_icon icon[FLAGS_MAX];
	s_SC_MP_EnumPlayers enum_pl[64];
	BOOL side[2];
	s_SC_MP_SRV_settings SRVset;
	dword index_rec[FLAGS_MAX+1];
#if _GE_VERSION_ >= 138
	s_SC_FpvMapSign fpv_list[FLAGS_MAX];
#endif

	switch(info->message){
		
		case SC_NET_MES_SERVER_TICK:			

			if (SRV_CheckEndRule(info->elapsed_time)) break;

			
			side[0] = side[1] = FALSE;
			j = 64;

			if (SC_MP_EnumPlayers(enum_pl,&j,SC_MP_ENUMPLAYER_SIDE_ALL)){


				if ((j==0)&&((gSidePoints[0]+gSidePoints[1])!=0)){
					gSidePoints[0] = 0;
					gSidePoints[1] = 0;
					UpdateSidePoints();
				}// if ((side[0]+side[1])==0)

				for (i=0;i<j;i++)
					if (enum_pl[i].status!=SC_MP_P_STATUS_NOTINGAME){
						
						if (enum_pl[i].side<2) side[enum_pl[i].side] = TRUE;

					}// if (enum_pl[i].status==SC_MP_P_STATUS_INGAME)

				gMission_starting_timer -= info->elapsed_time;

				if ((side[0])&&(side[1])){

					SC_MP_SetInstantRecovery(FALSE);

					if ((gPhase==PHASE_NONE)&&(gPhaseTime>2.0f)){
						gPhase = PHASE_RUNS;
						gMission_afterstart_time = 0.0f;
						SC_sgi(GVAR_PHASE,gPhase);

						if (gPhaseTime>5.0f){
							SC_MP_SRV_InitGameAfterInactive();
							ResetMission();
							SC_MP_RecoverAllNoAiPlayers();
						}	
						gMission_starting_timer = 8.0f;
					}
				}// if ((side[0])&&(side[1]))
				else{

					if (gMission_starting_timer<=0.0f){

						SC_MP_SetInstantRecovery(TRUE);

						if (gPhase==PHASE_RUNS){
							gPhase = PHASE_NONE;
							gMission_afterstart_time = 0.0f;
							SC_sgi(GVAR_PHASE,gPhase);
							ResetMission();
						}

					}

				}// else if ((side[0])&&(side[1]))

			}// if (SC_MP_EnumPlayers(enum_pl,&j,SC_MP_ENUMPLAYER_SIDE_ALL))
							
						

			for (j=0;j<2;j++)
			for (i=0;i<gRecs[j];i++)
				gRecTimer[j][i] -= info->elapsed_time;

			for (j=0;j<gFlags;j++)
				for (i=0;i<gRecsFl[j];i++)
					gRecTimerFl[j][i] -= info->elapsed_time;

			gNextRecover -= info->elapsed_time;
			if (gNextRecover<0.0f) gNextRecover = GetRecovTime(); 

			switch(gPhase){
				
				case PHASE_NONE:
					gPhaseTime += info->elapsed_time;
					break;
				
				case PHASE_RUNS:

					for (i=0;i<gFlags;i++){					
		
						vec = gOrigFlagPos[i];
								
						gMission_afterstart_time += info->elapsed_time;
					
						if (gMission_afterstart_time>10.0f){
							
							j = SC_GetNearestPlayer(&vec,&pl_dist);

							if ((j)&&(pl_dist<1.5f)){

								SC_P_GetInfo(j,&plinfo);						

								if (plinfo.side!=gFlagPhase[i]){
									gFlagPhase[i] = plinfo.side;
									gInfoPlHandle[i] = SC_MP_GetHandleofPl(j);
									switch(plinfo.side){
										case 0:
											gInfo[i]  = INFO_FL_CAPT_US;											
											break;
										case 1:
											gInfo[i]  = INFO_FL_CAPT_VC;											
											break;										
									}// switch(plinfo.side)
								}// if (plinfo.side!=gFlagPhase[i])

							}// if ((j)&&(pl_dist<1.0f))

						}// if (valid)

					}// for (i) - for both flags



					j = gFlagPhase[0];
					

					for (i=1;i<gFlags;i++)
						if (gFlagPhase[i]!=j) break;

					if ((i==gFlags)&&(j!=FLAG_NEUTRAL)){

						gOccupyTime -= info->elapsed_time;

						if (gOccupyTime<=0.0f){

							switch(j){
								case FLAG_US:
									gSidePoints[0]++;
									UpdateSidePoints();

									gPhase = PHASE_USWIN;
									gPhaseTime = 10.0f;
									SC_sgi(GVAR_PHASE,gPhase);															
									break;
								case FLAG_VC:
									gSidePoints[1]++;
									UpdateSidePoints();

									gPhase = PHASE_VCWIN;
									gPhaseTime = 10.0f;
									SC_sgi(GVAR_PHASE,gPhase);
									break;
							}// switch(j)

						}// gOccupyTime

					}// if (i==gFlags)
					else gOccupyTime = TOWIN_OCCUPY_TIME;

					break;

				case PHASE_USWIN:
				case PHASE_VCWIN:

					gPhaseTime -= info->elapsed_time;

					if (gPhaseTime<=0.0f){

						gPhase = PHASE_NONE;
						gPhaseTime = 0.0f;
						SC_sgi(GVAR_PHASE,gPhase);

						ResetMission();
						SC_MP_RestartMission();

					}// if (gPhaseTime<=0.0f)
			
					break;


			}// switch(gPhase)


			SRV_ChechSendStatus();

			break;

		case SC_NET_MES_CLIENT_TICK:	

			if (gCLN_HelpInfo_timer>0.0f){
				gCLN_HelpInfo_timer -= info->elapsed_time;
			}				

			pl_id = SC_PC_Get();			

			for (i=0;i<2;i++){

				gCLN_SidePoints[i] = SC_ggi(GVAR_SIDE0POINTS+i);			
				SC_MP_SetSideStats(i,0,gCLN_SidePoints[i]);

			}// for (i=0;i<2;i++)			

			
			for (i=0;i<gFlags;i++){
			
				gCLN_FlagPhase[i] = SC_ggi(GVAR_FLAGSTATUS+i);				


				fpv_list[i].color = 0xffffffff;
				fpv_list[i].pos = gOrigFlagPos[i];
				fpv_list[i].scale = 1.0f;				

				icon[i].color = 0xffffffff;				
				icon[i].type = SC_HUD_MP_ICON_TYPE_NONE;				
				
				
				switch(gCLN_FlagPhase[i]){

					case FLAG_US:
						fpv_list[i].id = g_FPV_UsFlag;
						icon[i].icon_id = 0;
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][0],FALSE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][1],TRUE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][2],TRUE);
						break;

					case FLAG_VC:
						fpv_list[i].id = g_FPV_VcFlag;
						icon[i].icon_id = 3;
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][0],TRUE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][1],FALSE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][2],TRUE);
						break;

					case FLAG_NEUTRAL:
						fpv_list[i].id = g_FPV_NeFlag;
						icon[i].icon_id = 12;
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][0],TRUE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][1],TRUE);
						SC_DUMMY_Set_DoNotRenHier2(gFlagNod[i][2],FALSE);
						break;
				}


				j = SC_ggi(GVAR_INFO+i);
				if (j!=gCLN_Info[i]){
					gCLN_Info[i] = j;
					gCLN_InfoPlHandle[i] = SC_ggi(GVAR_INFOPLHANDLE+i);		
					
					pl_id = SC_MP_GetPlofHandle(gCLN_InfoPlHandle[i]);


					switch(j){

						case INFO_FL_CAPT_US:								
								if (pl_id){
									swprintf(gCLN_HelpInfo,SC_Wtxt(1136),SC_P_GetName(pl_id),SC_Wtxt(1010),i+1);
									gCLN_HelpInfo_timer = 4.0f;
								}
								SC_SND_PlaySound2D(11117);
								break;
						case INFO_FL_CAPT_VC:								
								if (pl_id){
									swprintf(gCLN_HelpInfo,SC_Wtxt(1136),SC_P_GetName(pl_id),SC_Wtxt(1011),i+1);
									gCLN_HelpInfo_timer = 4.0f;
								}								
								SC_SND_PlaySound2D(11116);
								break;

					}// switch(j)										

					
				}// if (j!=gCLNd_Info[i])

				

			}// for (i)

			SC_MP_SetIconHUD(icon,gFlags);

			SC_MP_FpvMapSign_Set(gFlags,fpv_list);

			break;// SC_NET_MES_CLIENT_TICK


		case SC_NET_MES_LEVELPREINIT:
			SC_sgi(GVAR_MP_MISSIONTYPE,GVAR_MP_MISSIONTYPE_RW);

			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;


			SC_MP_EnableBotsFromScene(FALSE);

			break;// SC_NET_MES_LEVELPREINIT

		case SC_NET_MES_LEVELINIT:
					
		#if _GE_VERSION_ >= 138
			g_FPV_UsFlag = SC_MP_FpvMapSign_Load("g\\weapons\\Vvh_map\\icons\\MPIC_USflag.BES");
			g_FPV_VcFlag = SC_MP_FpvMapSign_Load("g\\weapons\\Vvh_map\\icons\\MPIC_VCflag.BES");
			g_FPV_NeFlag = SC_MP_FpvMapSign_Load("g\\weapons\\Vvh_map\\icons\\MPIC_emptyflag.BES");
		#endif

			
			SC_MP_SRV_SetForceSide(0xffffffff);
			SC_MP_SetChooseValidSides(3);

			SC_MP_SRV_SetClassLimit(18,0);
			SC_MP_SRV_SetClassLimit(19,0);
			SC_MP_SRV_SetClassLimit(39,0);

			SC_MP_GetSRVsettings(&SRVset);

			for (i=0;i<6;i++){
				SC_MP_SRV_SetClassLimit(i+1,SRVset.atg_class_limit[i]);
				SC_MP_SRV_SetClassLimit(i+21,SRVset.atg_class_limit[i]);
			}// for (i)


			CLEAR(hudinfo);
			hudinfo.title = 1178;
			
			hudinfo.sort_by[0] = SC_HUD_MP_SORTBY_KILLS;
			hudinfo.sort_by[1] = SC_HUD_MP_SORTBY_DEATHS | SC_HUD_MP_SORT_DOWNUP;
			hudinfo.sort_by[2] = SC_HUD_MP_SORTBY_PINGS | SC_HUD_MP_SORT_DOWNUP;

			hudinfo.pl_mask = SC_HUD_MP_PL_MASK_CLASS | SC_HUD_MP_PL_MASK_KILLS | SC_HUD_MP_PL_MASK_DEATHS;
			hudinfo.use_sides = TRUE;
			hudinfo.side_name[0] = 1010;
			hudinfo.side_color[0] = 0x440000ff;
			hudinfo.side_name[1] = 1011;
			hudinfo.side_color[1] = 0x44ff0000;

			hudinfo.side_mask = SC_HUD_MP_SIDE_MASK_POINTS;

			SC_MP_HUD_SetTabInfo(&hudinfo);

			SC_MP_AllowStPwD(TRUE);
			SC_MP_AllowFriendlyFireOFF(TRUE);

			SC_MP_SetItemsNoDisappear(FALSE);

			gPhase = PHASE_NONE;

			if (info->param2){

				// preload flag items
				SC_Item_Preload(145);
				SC_Item_Preload(146);


				gFlags = 0;

				for (i=0;i<FLAGS_MAX;i++){

					sprintf(txt,"W%c_flag",'A'+i);
					nod = SC_NOD_GetNoMessage(NULL,txt);

					if (nod){

						gFlagIndex[gFlags] = i;

						gFlagNod[gFlags][0] = SC_NOD_Get(nod,"vlajkaUS");
						gFlagNod[gFlags][1] = SC_NOD_Get(nod,"Vlajka VC");
						gFlagNod[gFlags][2] = SC_NOD_Get(nod,"vlajka N");

						if (!gFlagNod[gFlags][0]) SC_message("vlajkaUS not found: %s",txt);
						if (!gFlagNod[gFlags][1]) SC_message("Vlajka VC not found: %s",txt);
						if (!gFlagNod[gFlags][2]) SC_message("neutral not found: %s",txt);

						SC_NOD_GetWorldPos(nod,&gOrigFlagPos[gFlags]);

						gFlags++;

					}// if (nod)

				}// for (i)


				if (info->param1){
					// it's server		
					
					SC_MP_Gvar_SetSynchro(GVAR_SIDE0POINTS);
					SC_MP_Gvar_SetSynchro(GVAR_SIDE1POINTS);
					UpdateSidePoints();

					SC_MP_Gvar_SetSynchro(GVAR_PHASE);
					SC_sgi(GVAR_PHASE,0);
					

					for (i=0;i<gFlags;i++){
						SC_MP_Gvar_SetSynchro(GVAR_FLAGSTATUS+i);
						SC_sgi(GVAR_FLAGSTATUS+i,FLAG_NEUTRAL);

						SC_MP_Gvar_SetSynchro(GVAR_INFO+i);
						SC_sgi(GVAR_INFO+i,INFO_FL_NONE);

						SC_MP_Gvar_SetSynchro(GVAR_INFOPLHANDLE+i);
						SC_sgi(GVAR_INFOPLHANDLE+i,0);						
					}

										

					// recovers for sides

					CLEAR(gRecs);

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME_US,i);			
						if (SC_NET_FillRecover(&gRec[0][gRecs[0]],txt)) gRecs[0]++;					
					}					

#if _GE_VERSION_ >= 133
					i = REC_MAX - gRecs[0];
					SC_MP_GetRecovers(SC_MP_RESPAWN_RW_US,&gRec[0][gRecs[0]],&i);
					gRecs[0] += i;
#endif

					SC_Log(3,"RW respawns us: %d",gRecs[0]);


					if (gRecs[0]==0) SC_message("no US recover place defined!");

					for (i=0;i<REC_MAX;i++){		
						sprintf(txt,REC_WPNAME_VC,i);			
						if (SC_NET_FillRecover(&gRec[1][gRecs[1]],txt)) gRecs[1]++;
					}					

#if _GE_VERSION_ >= 133
					i = REC_MAX - gRecs[1];
					SC_MP_GetRecovers(SC_MP_RESPAWN_RW_VC,&gRec[1][gRecs[1]],&i);
					gRecs[1] += i;
#endif

					SC_Log(3,"RW respawns vc: %d",gRecs[1]);


					if (gRecs[1]==0) SC_message("no VC recover place defined!");					

					CLEAR(gRecTimer);

					// recovers for flags

					for (i=0;i<gFlags;i++){

						for (j=0;j<REC_MAX;j++){

							sprintf(txt,"W%cSpawn%d",'A'+gFlagIndex[i],j);

							if (SC_NET_FillRecover(&gRecFl[i][gRecsFl[i]],txt)) gRecsFl[i]++;					

						}// for (j)
						
#if _GE_VERSION_ >= 133
						j = REC_MAX - gRecsFl[i];
						SC_MP_GetRecovers(gRespawn_id[gFlagIndex[i]],&gRecFl[i][gRecsFl[i]],&j);
						gRecsFl[i] += j;
#endif

						SC_Log(3,"RW %c respawns : %d",'A'+gFlagIndex[i],gRecsFl[i]);
						
					}// for (i)


				}// if (info->param1)

			}//if (info->param2)


			break;// SC_NET_MES_LEVELINIT


		case SC_NET_MES_RENDERHUD:

			txt_id = 0;
		
			switch(SC_ggi(GVAR_PHASE)){
									
				case PHASE_NONE:
					middle = 0;
					txt_id = 101;
					break;

				case PHASE_USWIN:
					middle = 1;
					txt_id = 1099;
					break;

				case PHASE_VCWIN:
					middle = 1;
					txt_id = 1081;
					break;
			}// switch(SC_ggi(GVAR_PHASE))



			if ((txt_id)||(gCLN_HelpInfo_timer>0.0f)){

				SC_GetScreenRes(&pl_dist,&yres);

				if (gCLN_HelpInfo_timer<=0.0f)
					iwtxt = SC_Wtxt(txt_id);
				else{
					middle = 0;
					iwtxt = gCLN_HelpInfo;
				}

				pl_dist -= SC_Fnt_GetWidthW(iwtxt,1);
				
				if (middle) yres = yres * 0.45f;
					else yres = 15;

				SC_Fnt_WriteW(pl_dist * 0.5f,yres,iwtxt,1,0xffffffff);
				
			}// itxt
			
			
			break;

		case SC_NET_MES_SERVER_RECOVER_TIME:

			if (info->param2){
					info->fval1 = 0.1f;
			}
			else{
				// killed
				switch(gPhase){
					case PHASE_NONE:
							info->fval1 = 3.0f;
							break;
					case PHASE_RUNS:
							if (gNextRecover>GetRecovLimitTime()) info->fval1 = gNextRecover;
								else info->fval1 = gNextRecover + GetRecovTime();
								break;
					default:
						info->fval1 = -1.0f;
						break;
				}// switch(gPhase)

							
			}

			break;

		case SC_NET_MES_SERVER_RECOVER_PLACE:			

			// choose side/village

			k = 0;

			for (i=0;i<gFlags;i++)
				if (gFlagPhase[i]==info->param1){
					index_rec[k] = i;
					k++;
				}

			index_rec[k] = 0xff;
			k++;

			k = index_rec[rand()%k];			
			
			precov = (s_SC_MP_Recover*)info->param2;

			if (k==0xff){					
				// side recover
				i = SC_MP_SRV_GetBestDMrecov(gRec[info->param1],gRecs[info->param1],gRecTimer[info->param1],NORECOV_TIME);			
				gRecTimer[info->param1][i] = NORECOV_TIME;
				*precov = gRec[info->param1][i];
			}
			else{
				// village recover
				i = SC_MP_SRV_GetBestDMrecov(gRecFl[k],gRecsFl[k],gRecTimerFl[k],NORECOV_TIME);			
				gRecTimerFl[k][i] = NORECOV_TIME;
				*precov = gRecFl[k][i];
			}
						
			break;
			

		case SC_NET_MES_SERVER_KILL:

			Check_ABL(info->param1);
			
			break;// SC_NET_MES_SERVER_KILL

		case SC_NET_MES_RESTARTMAP:


			CLEAR(gInfo);
			CLEAR(gSend_Info);
		
			gMission_afterstart_time = 0.0f;
			gMission_starting_timer = 0.0f;

			CLEAR(gRecTimerFl);
			CLEAR(gRecTimer);

			gNextRecover = 0.0f;

			CLEAR(gSidePoints);
			UpdateSidePoints();

			gPhase = PHASE_NONE;
			gPhaseTime = 0.0f;

			gTime = 0;

			gOccupyTime = TOWIN_OCCUPY_TIME;

			for (i=0;i<FLAGS_MAX;i++){
				gFlagPhase[i] = FLAG_NEUTRAL;
				gSend_FlagPhase[i] = 99;
			}
			
			SC_MP_SetInstantRecovery(TRUE);

			SC_MP_SRV_ClearPlsStats();

			SC_MP_SRV_InitGameAfterInactive();
			SC_MP_RecoverAllNoAiPlayers();			

			break;// SC_NET_MES_RESTARTMAP

		case SC_NET_MES_RULESCHANGED:			
			gEndRule = info->param1;
			gEndValue = info->param2;
			gTime = 0.0f;
			break;
			
	}// switch(info->message)
	

	return 1;

}// int ScriptMain(void)
